/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.druid.util.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.common.util.PinyinUtils;
import vip.xiaonuo.disk.domain.KeyWord;
import vip.xiaonuo.disk.mapper.KeyWordMapper;
import vip.xiaonuo.disk.param.KeyWordAddParam;
import vip.xiaonuo.disk.param.KeyWordEditParam;
import vip.xiaonuo.disk.param.KeyWordIdParam;
import vip.xiaonuo.disk.param.KeyWordPageParam;
import vip.xiaonuo.disk.service.KeyWordService;

import java.util.List;

/**
 * key_wordService接口实现类
 *
 * @author pans
 * @date  2025/06/27 10:08
 **/
@Service
public class KeyWordServiceImpl extends ServiceImpl<KeyWordMapper, KeyWord> implements KeyWordService {
    @Autowired
    private KeyWordMapper keyWordMapper;
    @Override
    public Page<KeyWord> page(KeyWordPageParam keyWordPageParam) {
        QueryWrapper<KeyWord> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isNotEmpty(keyWordPageParam.getWordName())) {
            queryWrapper.lambda().like(KeyWord::getWordName, keyWordPageParam.getWordName());
        }
        if(ObjectUtil.isNotEmpty(keyWordPageParam.getWordPy())) {
            queryWrapper.lambda().like(KeyWord::getWordPy, keyWordPageParam.getWordPy());
        }
        if(ObjectUtil.isAllNotEmpty(keyWordPageParam.getSortField(), keyWordPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(keyWordPageParam.getSortOrder());
            queryWrapper.orderBy(true, keyWordPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(keyWordPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(KeyWord::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(KeyWordAddParam keyWordAddParam) {
        KeyWord keyWord = BeanUtil.toBean(keyWordAddParam, KeyWord.class);
        keyWord.setWordPy(PinyinUtils.toPinyin(keyWordAddParam.getWordName()));
        this.save(keyWord);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(KeyWordEditParam keyWordEditParam) {
        KeyWord keyWord = this.queryEntity(keyWordEditParam.getId());
        BeanUtil.copyProperties(keyWordEditParam, keyWord);
        keyWord.setWordPy(PinyinUtils.toPinyin(keyWordEditParam.getWordName()));
        this.updateById(keyWord);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<KeyWordIdParam> keyWordIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(keyWordIdParamList, KeyWordIdParam::getId));
    }

    @Override
    public KeyWord detail(KeyWordIdParam keyWordIdParam) {
        return this.queryEntity(keyWordIdParam.getId());
    }

    @Override
    public KeyWord queryEntity(Integer id) {
        KeyWord keyWord = this.getById(id);
        if(ObjectUtil.isEmpty(keyWord)) {
            throw new CommonException("key_word不存在，id值为：{}", id);
        }
        return keyWord;
    }

    @Override
    public List<KeyWord> select(String popular) {
        QueryWrapper<KeyWord> queryWrapper = new QueryWrapper<>();
        if(StringUtils.equals(popular, "1")){
            queryWrapper.lambda().like(KeyWord::getPopular,"1");
        }else if(StringUtils.equals(popular, "0")){
            queryWrapper.lambda().like(KeyWord::getPopular,"0");
        }
        queryWrapper.lambda().orderByAsc(KeyWord::getId);
        return keyWordMapper.selectList(queryWrapper);
    }

}
